/*
    Copyright (C) 2021  Rob van den Berg

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef COLORS_HPP
#define COLORS_HPP

#include "Color.hpp"

namespace cbcol{

// exported from https=//coolors.co/fffcf2-ccc5b9-403d39-252422-eb5e28
static const Color floral_white(255, 252, 242);

static const Color pale_silver(204, 197, 185);

static const Color black_olive(64, 61, 57);
static const Color black_olive_1(170, 163, 153);
static const Color black_olive_2(120, 114, 107);
static const Color black_olive_3(31, 27, 22);
static const Color black_olive_4(35, 27, 17);

static const Color eerie_black(37, 36, 34);
static const Color eerie_black_1(154, 150, 140);
static const Color eerie_black_2(101, 98, 92);
static const Color eerie_black_3(23, 20, 16);
static const Color eerie_black_4(26, 21, 12);

static const Color flame(235, 94, 40);
static const Color flame_1(255, 159, 124);
static const Color flame_2(251, 127, 82);
static const Color flame_3(194, 62, 13);
static const Color flame_4(154, 42, 0);

static const Color saffron(235, 190, 40);
static const Color saffron_1(255, 225, 124);
static const Color saffron_2(251, 212, 82);
static const Color saffron_3(194, 153, 13);
static const Color saffron_4(154, 118, 0);

static const Color blue_pigment(55, 47, 164);
static const Color blue_pigment_1(116, 110, 198);
static const Color blue_pigment_2(81, 73, 175);
static const Color blue_pigment_3(35, 27, 135);
static const Color blue_pigment_4(21, 14, 107);

static const Color shamrock_green(28, 162, 101);
static const Color shamrock_green_1(95, 197, 151);
static const Color shamrock_green_2(57, 173, 120);
static const Color shamrock_green_3(9, 134, 77);
static const Color shamrock_green_4(0, 106, 58);

/* Generated by Palettoncom © 2002_2014 */
/* http=//palettoncom */

/* SCSS Gradient
$gradient-top= linear-gradient(0deg, #fffcf2ff, #ccc5b9ff, #403d39ff, #252422ff, #eb5e28ff);
$gradient-right= linear-gradient(90deg, #fffcf2ff, #ccc5b9ff, #403d39ff, #252422ff, #eb5e28ff);
$gradient-bottom= linear-gradient(180deg, #fffcf2ff, #ccc5b9ff, #403d39ff, #252422ff, #eb5e28ff);
$gradient-left= linear-gradient(270deg, #fffcf2ff, #ccc5b9ff, #403d39ff, #252422ff, #eb5e28ff);
$gradient-top-right= linear-gradient(45deg, #fffcf2ff, #ccc5b9ff, #403d39ff, #252422ff, #eb5e28ff);
$gradient-bottom-right= linear-gradient(135deg, #fffcf2ff, #ccc5b9ff, #403d39ff, #252422ff, #eb5e28ff);
$gradient-top-left= linear-gradient(225deg, #fffcf2ff, #ccc5b9ff, #403d39ff, #252422ff, #eb5e28ff);
$gradient-bottom-left= linear-gradient(315deg, #fffcf2ff, #ccc5b9ff, #403d39ff, #252422ff, #eb5e28ff);
$gradient-radial= radial-gradient(#fffcf2ff, #ccc5b9ff, #403d39ff, #252422ff, #eb5e28ff);
 */
}
#endif